Index: modules/RunPUPPI.cc
===================================================================
--- modules/RunPUPPI.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ modules/RunPUPPI.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,262 @@
+#include "modules/RunPUPPI.h"
+
+#include "PUPPI/puppiCleanContainer.hh"
+#include "PUPPI/RecoObj.hh"
+#include "PUPPI/puppiParticle.hh"
+#include "PUPPI/puppiAlgoBin.hh"
+
+#include "classes/DelphesClasses.h"
+#include "classes/DelphesFactory.h"
+#include "classes/DelphesFormula.h"
+
+#include <algorithm> 
+#include <stdexcept>
+#include <iostream>
+#include <sstream>
+#include <vector>
+
+using namespace std;
+
+//------------------------------------------------------------------------------
+RunPUPPI::RunPUPPI() :
+  fItTrackInputArray(0), 
+  fItNeutralInputArray(0)
+{}
+
+//------------------------------------------------------------------------------
+RunPUPPI::~RunPUPPI(){}
+
+//------------------------------------------------------------------------------
+
+void RunPUPPI::Init(){
+
+  // input collection
+  fTrackInputArray     = ImportArray(GetString("TrackInputArray", "Calorimeter/towers"));
+  fItTrackInputArray   = fTrackInputArray->MakeIterator();
+  fNeutralInputArray   = ImportArray(GetString("NeutralInputArray", "Calorimeter/towers"));
+  fItNeutralInputArray = fNeutralInputArray->MakeIterator();
+  fPVInputArray        = ImportArray(GetString("PVInputArray", "PV"));
+  fPVItInputArray      = fPVInputArray->MakeIterator();
+
+
+  // puppi parameters                                     
+  fMinPuppiWeight = GetDouble("MinPuppiWeight", 0.01);
+  fUseExp         = GetBool("UseExp", false);
+
+  // read eta min ranges                                                                                                                                                           
+  ExRootConfParam param = GetParam("EtaMinBin");
+  fEtaMinBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fEtaMinBin.push_back(param[iMap].GetDouble());
+
+  // read eta max ranges                                                                                                                                                           
+  param = GetParam("EtaMaxBin");
+  fEtaMaxBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fEtaMaxBin.push_back(param[iMap].GetDouble());
+
+  // read pt min value                                                                                                                                                           
+  param = GetParam("PtMinBin");
+  fPtMinBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fPtMinBin.push_back(param[iMap].GetDouble());
+
+  // read cone size                                                                                                                                                           
+  param = GetParam("ConeSizeBin");
+  fConeSizeBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fConeSizeBin.push_back(param[iMap].GetDouble());
+
+  // read RMS min pt                                                                                                                                             
+  param = GetParam("RMSPtMinBin");
+  fRMSPtMinBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fRMSPtMinBin.push_back(param[iMap].GetDouble());
+
+  // read RMS scale factor                                                                                                                                                           
+  param = GetParam("RMSScaleFactorBin");
+  fRMSScaleFactorBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fRMSScaleFactorBin.push_back(param[iMap].GetDouble());
+
+  // read neutral pt min cut                                                                                                                                                           
+  param = GetParam("NeutralMinEBin");
+  fNeutralMinEBin.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fNeutralMinEBin.push_back(param[iMap].GetDouble());
+
+  // read neutral pt min slope                                                                                                                                                           
+  param = GetParam("NeutralPtSlope");
+  fNeutralPtSlope.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fNeutralPtSlope.push_back(param[iMap].GetDouble());
+
+  // read apply chs                                                                                                                                                           
+  param = GetParam("ApplyCHS");
+  fApplyCHS.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fApplyCHS.push_back(param[iMap].GetBool());
+
+  // read use charged                                                                                                                                                           
+  param = GetParam("UseCharged");
+  fUseCharged.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fUseCharged.push_back(param[iMap].GetBool());
+
+  // read apply chs correction                                                                                                                                                           
+  param = GetParam("ApplyLowPUCorr");
+  fApplyLowPUCorr.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fApplyLowPUCorr.push_back(param[iMap].GetBool());
+  
+  // read metric id                                                                                                                                                          
+  param = GetParam("MetricId");
+  fMetricId.clear();
+  for(int iMap = 0; iMap < param.GetSize(); ++iMap) fMetricId.push_back(param[iMap].GetInt());
+
+  // create output array
+  fOutputArray        = ExportArray(GetString("OutputArray", "puppiParticles"));
+  fOutputTrackArray   = ExportArray(GetString("OutputArrayTracks", "puppiTracks"));
+  fOutputNeutralArray = ExportArray(GetString("OutputArrayNeutrals", "puppiNeutrals"));
+}
+
+//------------------------------------------------------------------------------
+
+void RunPUPPI::Finish(){
+  if(fItTrackInputArray)   delete fItTrackInputArray;
+  if(fItNeutralInputArray) delete fItNeutralInputArray;
+}
+
+//------------------------------------------------------------------------------
+
+void RunPUPPI::Process(){
+
+  Candidate *candidate, *particle;
+  TLorentzVector momentum;
+
+  DelphesFactory *factory = GetFactory();
+
+  // loop over input objects
+  fItTrackInputArray->Reset();
+  fItNeutralInputArray->Reset();
+  fPVItInputArray->Reset();
+
+  std::vector<Candidate> InputParticles;
+  InputParticles.clear();
+
+  // take the leading vertex 
+  float PVZ = 0.;
+  Candidate *pv = static_cast<Candidate*>(fPVItInputArray->Next());
+  if (pv) PVZ = pv->Position.Z();
+
+  // Fill input particles for puppi
+  std::vector<RecoObj> puppiInputVector;
+
+  // Loop on charge track candidate
+  while((candidate = static_cast<Candidate*>(fItTrackInputArray->Next()))){   
+
+      momentum = candidate->Momentum;
+      
+      RecoObj curRecoObj;
+      curRecoObj.pt  = momentum.Pt();
+      curRecoObj.eta = momentum.Eta();
+      curRecoObj.phi = momentum.Phi();
+      curRecoObj.m   = momentum.M();  
+      particle = static_cast<Candidate*>(candidate->GetCandidates()->Last());
+      if (candidate->IsRecoPU and candidate->Charge !=0) { // if it comes fromPU vertexes after the resolution smearing and the dZ matching within resolution
+	curRecoObj.id    = 2;
+	curRecoObj.vtxId = candidate->IsPU;
+	if(TMath::Abs(candidate->PID) == 11)      curRecoObj.pfType = 2;
+	else if(TMath::Abs(candidate->PID) == 13) curRecoObj.pfType = 3;
+	else if(TMath::Abs(candidate->PID) == 22) curRecoObj.pfType = 4;
+        else curRecoObj.pfType = 1;
+        curRecoObj.dZ = particle->Position.Z()-PVZ;
+      } 
+      else if(!candidate->IsRecoPU and candidate->Charge !=0) {
+	curRecoObj.id    = 1;  // charge from LV
+        curRecoObj.vtxId = 1; // from PV
+	if(TMath::Abs(candidate->PID) == 11)      curRecoObj.pfType = 2;
+	else if(TMath::Abs(candidate->PID) == 13) curRecoObj.pfType = 3;
+	else if(TMath::Abs(candidate->PID) == 22) curRecoObj.pfType = 4;
+        else curRecoObj.pfType = 1;
+        curRecoObj.dZ = particle->Position.Z()-PVZ;
+      }
+      else {
+	std::cerr<<" RunPUPPI: problem with a charged track --> it has charge 0 "<<std::endl;
+        continue;
+      }
+
+      puppiInputVector.push_back(curRecoObj);
+      InputParticles.push_back(*candidate);
+  }
+
+  // Loop on neutral calo cells 
+  while((candidate = static_cast<Candidate*>(fItNeutralInputArray->Next()))){
+
+      momentum = candidate->Momentum;
+
+      RecoObj curRecoObj;
+      curRecoObj.pt  = momentum.Pt();
+      curRecoObj.eta = momentum.Eta();
+      curRecoObj.phi = momentum.Phi();
+      curRecoObj.m   = momentum.M();
+      particle = static_cast<Candidate*>(candidate->GetCandidates()->Last());
+
+
+      if(candidate->Charge == 0){
+	curRecoObj.id    = 0; // neutrals have id==0
+	curRecoObj.vtxId = 0; // neutrals have vtxId==0 
+	if(TMath::Abs(candidate->PID) == 11)      curRecoObj.pfType = 2;
+	else if(TMath::Abs(candidate->PID) == 13) curRecoObj.pfType = 3;
+	else if(TMath::Abs(candidate->PID) == 22) curRecoObj.pfType = 4;
+        else curRecoObj.pfType = 5;
+        curRecoObj.dZ = particle->Position.Z()-PVZ;
+      }
+      else{
+	std::cerr<<" RunPUPPI: problem with a neutrals cells --> it has charge !=0 "<<std::endl;
+        continue;
+      }
+      puppiInputVector.push_back(curRecoObj);
+      InputParticles.push_back(*candidate);
+  }
+
+  // Create algorithm list for puppi
+  std::vector<puppiAlgoBin> puppiAlgo;
+  if(puppiAlgo.empty()){
+   if(!(fEtaMinBin.size() == fEtaMaxBin.size() and fEtaMinBin.size() == fPtMinBin.size() and fEtaMinBin.size() == fConeSizeBin.size() and fEtaMinBin.size() == fRMSPtMinBin.size()
+       and fEtaMinBin.size() == fRMSScaleFactorBin.size() and fEtaMinBin.size() == fNeutralMinEBin.size() and  fEtaMinBin.size() == fNeutralPtSlope.size() 
+       and fEtaMinBin.size() == fApplyCHS.size()  and fEtaMinBin.size() == fUseCharged.size()
+       and fEtaMinBin.size() == fApplyLowPUCorr.size() and fEtaMinBin.size() == fMetricId.size())) {
+    std::cerr<<" Error in PUPPI configuration, algo info should have the same size --> exit from the code"<<std::endl;
+    std::exit(EXIT_FAILURE);
+   } 
+
+   for( size_t iAlgo =  0 ; iAlgo < fEtaMinBin.size() ; iAlgo++){
+    puppiAlgoBin algoTmp ;
+    algoTmp.fEtaMin_ = fEtaMinBin.at(iAlgo);
+    algoTmp.fEtaMax_ = fEtaMaxBin.at(iAlgo);
+    algoTmp.fPtMin_  = fPtMinBin.at(iAlgo);
+    algoTmp.fConeSize_        = fConeSizeBin.at(iAlgo);
+    algoTmp.fRMSPtMin_        = fRMSPtMinBin.at(iAlgo);
+    algoTmp.fRMSScaleFactor_  = fRMSScaleFactorBin.at(iAlgo);
+    algoTmp.fNeutralMinE_     = fNeutralMinEBin.at(iAlgo);
+    algoTmp.fNeutralPtSlope_  = fNeutralPtSlope.at(iAlgo);
+    algoTmp.fApplyCHS_        = fApplyCHS.at(iAlgo);
+    algoTmp.fUseCharged_      = fUseCharged.at(iAlgo);
+    algoTmp.fApplyLowPUCorr_  = fApplyLowPUCorr.at(iAlgo);
+    algoTmp.fMetricId_        = fMetricId.at(iAlgo);
+    if(std::find(puppiAlgo.begin(),puppiAlgo.end(),algoTmp) != puppiAlgo.end()) continue;    
+    puppiAlgo.push_back(algoTmp);     
+   }
+  }  
+
+  // Create PUPPI container
+  puppiCleanContainer curEvent(puppiInputVector,puppiAlgo,fMinPuppiWeight,fUseExp);
+  std::vector<fastjet::PseudoJet> puppiParticles = curEvent.puppiEvent();
+
+  // Loop on final particles
+  for (std::vector<fastjet::PseudoJet>::iterator it = puppiParticles.begin() ; it != puppiParticles.end() ; it++) {
+    if(it->user_index() <= int(InputParticles.size())){      
+      candidate = factory->NewCandidate();
+      candidate = dynamic_cast<Candidate*>(InputParticles.at(it->user_index()).Clone());
+      candidate->Momentum.SetXYZT(it->px(),it->py(),it->pz(),it->e());
+      fOutputArray->Add(candidate);
+      if( puppiInputVector.at(it->user_index()).id == 1 or puppiInputVector.at(it->user_index()).id == 2) fOutputTrackArray->Add(candidate);
+      else if (puppiInputVector.at(it->user_index()).id == 0) fOutputNeutralArray->Add(candidate);
+    }
+    else{ 
+      std::cerr<<" particle not found in the input Array --> skip "<<std::endl;
+      continue;
+    }     
+  }
+
+}
Index: modules/RunPUPPI.h
===================================================================
--- modules/RunPUPPI.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
+++ modules/RunPUPPI.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -0,0 +1,56 @@
+#ifndef RunPUPPI_h
+#define RunPUPPI_h
+
+#include "classes/DelphesModule.h"
+#include <vector>
+
+class TObjArray;
+class TIterator;
+
+
+class RunPUPPI: public DelphesModule {
+
+ public:
+
+  RunPUPPI();
+  ~RunPUPPI();
+
+  void Init();
+  void Process();
+  void Finish();
+  
+ private:
+
+  TIterator *fItTrackInputArray;
+  TIterator *fItNeutralInputArray; //!
+  TIterator *fPVItInputArray; //!                                                                                                                                                      
+  
+  const TObjArray *fTrackInputArray;
+  const TObjArray *fNeutralInputArray; //!
+  const TObjArray *fPVInputArray; //!                                                                                                                                                     
+ 
+  // puppi parameters
+  float fMinPuppiWeight;
+  bool fUseExp;
+  
+  std::vector<float> fEtaMinBin ;
+  std::vector<float> fEtaMaxBin ;
+  std::vector<float> fPtMinBin ;
+  std::vector<float> fConeSizeBin ;
+  std::vector<float> fRMSPtMinBin ;
+  std::vector<float> fRMSScaleFactorBin ;
+  std::vector<float> fNeutralMinEBin;
+  std::vector<float> fNeutralPtSlope;
+  std::vector<bool>  fApplyCHS;
+  std::vector<bool>  fUseCharged;
+  std::vector<bool>  fApplyLowPUCorr;
+  std::vector<int>   fMetricId;
+
+  TObjArray *fOutputArray;
+  TObjArray *fOutputTrackArray;
+  TObjArray *fOutputNeutralArray;
+
+  ClassDef(RunPUPPI, 1)
+};
+
+#endif
Index: modules/TrackPileUpSubtractor.cc
===================================================================
--- modules/TrackPileUpSubtractor.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/TrackPileUpSubtractor.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -74,6 +74,7 @@
   fZVertexResolution  = GetDouble("ZVertexResolution", 0.005)*1.0E3;
 
+  fPTMin = GetDouble("PTMin", 0.);
   // import arrays with output from other modules
-
+   
   ExRootConfParam param = GetParam("InputArray");
   Long_t i, size;
@@ -147,7 +148,10 @@
       // assume perfect pile-up subtraction for tracks outside fZVertexResolution
       
-      if(candidate->IsPU && TMath::Abs(z-zvtx) > fZVertexResolution) continue;
-
-      array->Add(candidate);
+      if(candidate->IsPU && TMath::Abs(z-zvtx) > fZVertexResolution) candidate->IsRecoPU = 1;
+      else 
+      {
+         candidate->IsRecoPU = 0;
+         if( candidate->Momentum.Pt() > fPTMin) array->Add(candidate);
+      }
     }
   }
Index: modules/TrackPileUpSubtractor.h
===================================================================
--- modules/TrackPileUpSubtractor.h	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/TrackPileUpSubtractor.h	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -50,4 +50,6 @@
   Double_t fZVertexResolution;
 
+  Double_t fPTMin; 
+
   std::map< TIterator *, TObjArray * > fInputMap; //!
 
Index: modules/TreeWriter.cc
===================================================================
--- modules/TreeWriter.cc	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ modules/TreeWriter.cc	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -291,5 +291,5 @@
     entry->ZOuter = position.Z();
     entry->TOuter = position.T()*1.0E-3/c_light;
-    
+
     entry->Dxy = candidate->Dxy;
     entry->SDxy = candidate->SDxy ;
@@ -297,5 +297,5 @@
     entry->Yd = candidate->Yd;
     entry->Zd = candidate->Zd;
-   
+
     const TLorentzVector &momentum = candidate->Momentum;
 
@@ -362,4 +362,5 @@
 
     entry->T = position.T()*1.0E-3/c_light;
+    entry->Ntimes = candidate->Ntimes;
 
     FillParticles(candidate, &entry->Particles);
@@ -403,4 +404,13 @@
     entry->T = position.T()*1.0E-3/c_light;
 
+    // Isolation variables
+
+    entry->IsolationVar = candidate->IsolationVar;
+    entry->IsolationVarRhoCorr = candidate->IsolationVarRhoCorr ;
+    entry->SumPtCharged = candidate->SumPtCharged ;
+    entry->SumPtNeutral = candidate->SumPtNeutral ;
+    entry->SumPtChargedPU = candidate->SumPtChargedPU ;
+    entry->SumPt = candidate->SumPt ;
+
     entry->EhadOverEem = candidate->Eem > 0.0 ? candidate->Ehad/candidate->Eem : 999.9;
 
@@ -442,4 +452,14 @@
     entry->T = position.T()*1.0E-3/c_light;
 
+    // Isolation variables
+
+    entry->IsolationVar = candidate->IsolationVar;
+    entry->IsolationVarRhoCorr = candidate->IsolationVarRhoCorr ;
+    entry->SumPtCharged = candidate->SumPtCharged ;
+    entry->SumPtNeutral = candidate->SumPtNeutral ;
+    entry->SumPtChargedPU = candidate->SumPtChargedPU ;
+    entry->SumPt = candidate->SumPt ;
+
+
     entry->Charge = candidate->Charge;
 
@@ -488,4 +508,13 @@
     entry->T = position.T()*1.0E-3/c_light;
 
+    // Isolation variables
+
+    entry->IsolationVar = candidate->IsolationVar;
+    entry->IsolationVarRhoCorr = candidate->IsolationVarRhoCorr ;
+    entry->SumPtCharged = candidate->SumPtCharged ;
+    entry->SumPtNeutral = candidate->SumPtNeutral ;
+    entry->SumPtChargedPU = candidate->SumPtChargedPU ;
+    entry->SumPt = candidate->SumPt ;
+
     entry->Charge = candidate->Charge;
 
@@ -504,4 +533,5 @@
   Double_t ecalEnergy, hcalEnergy;
   const Double_t c_light = 2.99792458E8;
+  Int_t i;
 
   array->Sort();
@@ -532,8 +562,27 @@
     entry->Mass = momentum.M();
 
+    entry->Area = candidate->Area;
+
     entry->DeltaEta = candidate->DeltaEta;
     entry->DeltaPhi = candidate->DeltaPhi;
 
     entry->BTag = candidate->BTag;
+
+    entry->BTagAlgo = candidate->BTagAlgo;
+    entry->BTagDefault = candidate->BTagDefault;
+    entry->BTagPhysics = candidate->BTagPhysics;
+    entry->BTagNearest2 = candidate->BTagNearest2;
+    entry->BTagNearest3 = candidate->BTagNearest3;
+    entry->BTagHeaviest = candidate->BTagHeaviest;
+    entry->BTagHighestPt = candidate->BTagHighestPt;
+
+    entry->FlavorAlgo = candidate->FlavorAlgo;
+    entry->FlavorDefault = candidate->FlavorDefault;
+    entry->FlavorPhysics = candidate->FlavorPhysics;
+    entry->FlavorNearest2 = candidate->FlavorNearest2;
+    entry->FlavorNearest3 = candidate->FlavorNearest3;
+    entry->FlavorHeaviest = candidate->FlavorHeaviest;
+    entry->FlavorHighestPt = candidate->FlavorHighestPt;
+
     entry->TauTag = candidate->TauTag;
 
@@ -561,18 +610,20 @@
     entry->MeanSqDeltaR = candidate->MeanSqDeltaR;
     entry->PTD = candidate->PTD;
-    entry->FracPt[0] = candidate->FracPt[0];
-    entry->FracPt[1] = candidate->FracPt[1];
-    entry->FracPt[2] = candidate->FracPt[2];
-    entry->FracPt[3] = candidate->FracPt[3];
-    entry->FracPt[4] = candidate->FracPt[4];
-   
-    //--- N-subjettiness variables ----
-    
-    entry->Tau1 = candidate->Tau[0];
-    entry->Tau2 = candidate->Tau[1];
-    entry->Tau3 = candidate->Tau[2];
-    entry->Tau4 = candidate->Tau[3];
-    entry->Tau5 = candidate->Tau[4];
-   
+
+    //--- Sub-structure variables ----
+
+    entry->NSubJetsTrimmed = candidate->NSubJetsTrimmed;
+    entry->NSubJetsPruned = candidate->NSubJetsPruned;
+    entry->NSubJetsSoftDropped = candidate->NSubJetsSoftDropped;
+
+    for(i = 0; i < 5; i++)
+    {
+      entry->FracPt[i] = candidate -> FracPt[i];
+      entry->Tau[i] = candidate -> Tau[i];
+      entry->TrimmedP4[i] = candidate -> TrimmedP4[i];
+      entry->PrunedP4[i] = candidate -> PrunedP4[i];
+      entry->SoftDroppedP4[i] = candidate -> SoftDroppedP4[i];
+    }
+
     FillParticles(candidate, &entry->Particles);
   }
Index: readers/DelphesLHEF.cpp
===================================================================
--- readers/DelphesLHEF.cpp	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ readers/DelphesLHEF.cpp	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -63,5 +63,5 @@
   TStopwatch readStopWatch, procStopWatch;
   ExRootTreeWriter *treeWriter = 0;
-  ExRootTreeBranch *branchEvent = 0, *branchRwgt = 0;
+  ExRootTreeBranch *branchEvent = 0, *branchWeight = 0;
   ExRootConfReader *confReader = 0;
   Delphes *modularDelphes = 0;
@@ -103,5 +103,5 @@
 
     branchEvent = treeWriter->NewBranch("Event", LHEFEvent::Class());
-    branchRwgt = treeWriter->NewBranch("Rwgt", Weight::Class());
+    branchWeight = treeWriter->NewBranch("Weight", Weight::Class());
 
     confReader = new ExRootConfReader;
@@ -196,5 +196,5 @@
 
             reader->AnalyzeEvent(branchEvent, eventCounter, &readStopWatch, &procStopWatch);
-            reader->AnalyzeRwgt(branchRwgt);
+            reader->AnalyzeWeight(branchWeight);
 
             treeWriter->Fill();
Index: readers/DelphesPythia8.cpp
===================================================================
--- readers/DelphesPythia8.cpp	(revision f53a4d29acc13d296285ecd9b0a986c73a2c0efb)
+++ readers/DelphesPythia8.cpp	(revision d38348d6fa05d814372b4af29ec82c9928ff5be9)
@@ -20,4 +20,5 @@
 #include <iostream>
 #include <sstream>
+#include <string>
 
 #include <signal.h>
@@ -38,4 +39,5 @@
 #include "classes/DelphesClasses.h"
 #include "classes/DelphesFactory.h"
+#include "classes/DelphesLHEFReader.h"
 
 #include "ExRootAnalysis/ExRootTreeWriter.h"
@@ -149,12 +151,16 @@
   char appName[] = "DelphesPythia8";
   stringstream message;
+  FILE *inputFile = 0;
   TFile *outputFile = 0;
   TStopwatch readStopWatch, procStopWatch;
   ExRootTreeWriter *treeWriter = 0;
   ExRootTreeBranch *branchEvent = 0;
+  ExRootTreeBranch *branchEventLHEF = 0, *branchWeightLHEF = 0;
   ExRootConfReader *confReader = 0;
   Delphes *modularDelphes = 0;
   DelphesFactory *factory = 0;
   TObjArray *stableParticleOutputArray = 0, *allParticleOutputArray = 0, *partonOutputArray = 0;
+  TObjArray *stableParticleOutputArrayLHEF = 0, *allParticleOutputArrayLHEF = 0, *partonOutputArrayLHEF = 0;
+  DelphesLHEFReader *reader = 0;
   Long64_t eventCounter, errorCounter;
   Long64_t numberOfEvents, timesAllowErrors;
@@ -205,7 +211,5 @@
     partonOutputArray = modularDelphes->ExportArray("partons");
 
-    modularDelphes->InitTask();
-
-    // Initialize pythia
+    // Initialize Pythia
     pythia = new Pythia8::Pythia;
 
@@ -221,4 +225,20 @@
     numberOfEvents = pythia->mode("Main:numberOfEvents");
     timesAllowErrors = pythia->mode("Main:timesAllowErrors");
+
+    inputFile = fopen(pythia->word("Beams:LHEF").c_str(), "r");
+    if(inputFile)
+    {
+      reader = new DelphesLHEFReader;
+      reader->SetInputFile(inputFile);
+
+      branchEventLHEF = treeWriter->NewBranch("EventLHEF", LHEFEvent::Class());
+      branchWeightLHEF = treeWriter->NewBranch("WeightLHEF", LHEFWeight::Class());
+
+      allParticleOutputArrayLHEF = modularDelphes->ExportArray("allParticlesLHEF");
+      stableParticleOutputArrayLHEF = modularDelphes->ExportArray("stableParticlesLHEF");
+      partonOutputArrayLHEF = modularDelphes->ExportArray("partonsLHEF");
+    }
+
+    modularDelphes->InitTask();
 
     pythia->init();
@@ -234,8 +254,11 @@
     for(eventCounter = 0; eventCounter < numberOfEvents && !interrupted; ++eventCounter)
     {
+      while(reader && reader->ReadBlock(factory, allParticleOutputArrayLHEF,
+        stableParticleOutputArrayLHEF, partonOutputArrayLHEF) && !reader->EventReady());
+
       if(!pythia->next())
       {
         // If failure because reached end of file then exit event loop
-        if (pythia->info.atEndOfFile())
+        if(pythia->info.atEndOfFile())
         {
           cerr << "Aborted since reached end of Les Houches Event File" << endl;
@@ -244,7 +267,13 @@
 
         // First few failures write off as "acceptable" errors, then quit
-        if (++errorCounter < timesAllowErrors) continue;
-        cerr << "Event generation aborted prematurely, owing to error!" << endl;
-        break;
+        if(++errorCounter > timesAllowErrors)
+        {
+          cerr << "Event generation aborted prematurely, owing to error!" << endl;
+          break;
+        }
+
+        modularDelphes->Clear();
+        reader->Clear();
+        continue;
       }
 
@@ -258,8 +287,15 @@
       procStopWatch.Stop();
 
+      if(reader)
+      {
+        reader->AnalyzeEvent(branchEventLHEF, eventCounter, &readStopWatch, &procStopWatch);
+        reader->AnalyzeWeight(branchWeightLHEF);
+      }
+
       treeWriter->Fill();
 
       treeWriter->Clear();
       modularDelphes->Clear();
+      if(reader) reader->Clear();
 
       readStopWatch.Start();
@@ -277,4 +313,5 @@
     cout << "** Exiting..." << endl;
 
+    delete reader;
     delete pythia;
     delete modularDelphes;
